mydata<-read.csv("generalisation two ties twelth Nov.csv")
generalisation_ties <- read.csv("generalisation two ties twelth Nov.csv")
library(gnm)
library(BradleyTerry2)

triggerfish.tri <- expandCategorical(generalisation_ties, "Outcome",idvar= "trial")
 Davidson <- gnm(count ~ GenDavidson(Outcome==1, Outcome ==0, Outcome == -1,playerA, playerB) + Triggerfish_ID,eliminate = trial, family = poisson, data = triggerfish.tri)
Initialising
Running main iterations......
Done
> summary(Davidson)

Call:
  gnm(formula = count ~ GenDavidson(Outcome == 1, Outcome == 0, 
                                    Outcome == -1, playerA, playerB) + Triggerfish_ID, eliminate = trial,     family = poisson, data = triggerfish.tri)

Deviance Residuals: 
  Min       1Q   Median       3Q      Max  
-1.4871  -0.6685  -0.3420   0.2560   1.7406  

Coefficients of interest:
  Estimate Std. Error z value Pr(>|z|)   
tie.max           -1.0463     0.3617  -2.893  0.00381 **
  Redspots           2.6970         NA      NA       NA   
Yelbord           -0.6759         NA      NA       NA   
Yelbordredspots   -0.6837         NA      NA       NA   
Triggerfish_IDB    0.0000         NA      NA       NA   
Triggerfish_IDC    0.0000         NA      NA       NA   
Triggerfish_IDI    0.0000         NA      NA       NA   
Triggerfish_IDL    0.0000         NA      NA       NA   
Triggerfish_IDM    0.0000         NA      NA       NA   
Triggerfish_IDN    0.0000         NA      NA       NA   
Triggerfish_IDQ    0.0000         NA      NA       NA   
---
  Signif. codes:  0 '***' 0.001 '**' 0.01 '*' 0.05 '.' 0.1 ' ' 1

(Dispersion parameter for poisson family taken to be 1)

Std. Error is NA where coefficient has been constrained or is unidentified

Residual deviance: 52.913 on 63 degrees of freedom
AIC: 234.5

Number of iterations: 6

> Davidson2 <- gnm(count ~ GenDavidson(Outcome==1, Outcome ==0, Outcome == -1,
                                       +                                      playerA, playerB, home.adv = NULL,
                                       +                                      tie.max = ~1, tie.mode = NULL,
                                       +                                      tie.scale = NULL, at.home1 = NULL,
                                       +                                      at.home2 = NULL) - 1, family =
                     +                    poisson, data = triggerfish.tri)    


Deviance Residuals: 
  Min       1Q   Median       3Q      Max  
-1.4871  -0.6685  -0.3420   0.2560   1.7406  

Coefficients of interest:
  Estimate Std. Error z value Pr(>|z|)   
tie.max           -1.0463     0.3617  -2.893  0.00381 **
  Redspots           2.6970         NA      NA       NA   
Yelbord           -0.6759         NA      NA       NA   
Yelbordredspots   -0.6837         NA      NA       NA   
Triggerfish_IDB    0.0000         NA      NA       NA   
Triggerfish_IDC    0.0000         NA      NA       NA   
Triggerfish_IDI    0.0000         NA      NA       NA   
Triggerfish_IDL    0.0000         NA      NA       NA   
Triggerfish_IDM    0.0000         NA      NA       NA   
Triggerfish_IDN    0.0000         NA      NA       NA   
Triggerfish_IDQ    0.0000         NA      NA       NA   
---
  Signif. codes:  0 '***' 0.001 '**' 0.01 '*' 0.05 '.' 0.1 ' ' 1

(Dispersion parameter for poisson family taken to be 1)

Std. Error is NA where coefficient has been constrained or is unidentified

Residual deviance: 52.913 on 63 degrees of freedom
AIC: 234.5

Number of iterations: 6

> Davidson2 <- gnm(count ~ GenDavidson(Outcome==1, Outcome ==0, Outcome == -1,
                                       +                                      playerA, playerB, home.adv = NULL,
                                       +                                      tie.max = ~1, tie.mode = NULL,
                                       +                                      tie.scale = NULL, at.home1 = NULL,
                                       +                                      at.home2 = NULL) - 1, family =
                     +                    poisson, data = triggerfish.tri)    
Initialising
Running main iterations.......
Done
> 
  > summary(Davidson2)

Call:
  gnm(formula = count ~ GenDavidson(Outcome == 1, Outcome == 0, 
                                    Outcome == -1, playerA, playerB, home.adv = NULL, tie.max = ~1, 
                                    tie.mode = NULL, tie.scale = NULL, at.home1 = NULL, at.home2 = NULL) -     1, family = poisson, data = triggerfish.tri)


Deviance Residuals: 
  Initialising
Running main iterations.......
Done
> 
  > summary(Davidson2)

Call:
  gnm(formula = count ~ GenDavidson(Outcome == 1, Outcome == 0, 
                                    Outcome == -1, playerA, playerB, home.adv = NULL, tie.max = ~1, 
                                    tie.mode = NULL, tie.scale = NULL, at.home1 = NULL, at.home2 = NULL) -     1, family = poisson, data = triggerfish.tri)


Deviance Residuals: 
  Min       1Q   Median       3Q      Max  
-1.8656  -0.9873  -0.6841   0.6420   1.6192  

Coefficients:
  Estimate Std. Error z value Pr(>|z|)    
tie.max          -1.4854     0.3217  -4.617  3.9e-06 ***
  Redspots          0.5541     0.1606   3.450  0.00056 ***
  Yelbord          -0.7186     0.2900  -2.478  0.01321 *  
  Yelbordredspots  -0.6020     0.2862  -2.104  0.03541 *  
  ---
  Signif. codes:  0 '***' 0.001 '**' 0.01 '*' 0.05 '.' 0.1 ' ' 1

(Dispersion parameter for poisson family taken to be 1)

Residual deviance: 88.301 on 95 degrees of freedom
AIC: 205.89

Number of iterations: 7

> alphas <- exp(coef(Davidson2)[-1])
> probs <- alphas/sum(alphas)
> probs
Redspots         Yelbord Yelbordredspots 
0.6270343       0.1756169       0.1973489 
> vcov(Davidson2)
tie.max      Redspots       Yelbord Yelbordredspots
tie.max          0.10350685 -0.0104675319 -0.0276968100   -0.0251017467
Redspots        -0.01046753  0.0257856051  0.0005360138    0.0005859438
Yelbord         -0.02769681  0.0005360138  0.0841059387    0.0031816032
Yelbordredspots -0.02510175  0.0005859438  0.0031816032    0.0818867552
attr(,"dispersion")
[1] 1
attr(,"class")
[1] "vcov.gnm"
> covs <- vcov(Davidson2)
> covs <- covs[-1,-1]
> pd1 <- function (thetavec) { # function for partial derivatives
  +   tot <- sum(exp(thetavec))
  +   exp(thetavec[1])/tot - exp(2*thetavec[1])/tot^2
  + }
> 
  > pd2 <- function (index, thetavec) {
    +   tot <- sum(exp(thetavec))
    +   -(exp(thetavec[1] + thetavec[index])/tot^2)
    Min       1Q   Median       3Q      Max  
    -1.8656  -0.9873  -0.6841   0.6420   1.6192  
    
    Coefficients:
      Estimate Std. Error z value Pr(>|z|)    
    tie.max          -1.4854     0.3217  -4.617  3.9e-06 ***
      Redspots          0.5541     0.1606   3.450  0.00056 ***
      Yelbord          -0.7186     0.2900  -2.478  0.01321 *  
      Yelbordredspots  -0.6020     0.2862  -2.104  0.03541 *  
      ---
      Signif. codes:  0 '***' 0.001 '**' 0.01 '*' 0.05 '.' 0.1 ' ' 1
    
    (Dispersion parameter for poisson family taken to be 1)
    
    Residual deviance: 88.301 on 95 degrees of freedom
    AIC: 205.89
    
    Number of iterations: 7
    
    > alphas <- exp(coef(Davidson2)[-1])
    > probs <- alphas/sum(alphas)
    > probs
    Redspots         Yelbord Yelbordredspots 
    0.6270343       0.1756169       0.1973489 
    > vcov(Davidson2)
    tie.max      Redspots       Yelbord Yelbordredspots
    tie.max          0.10350685 -0.0104675319 -0.0276968100   -0.0251017467
    Redspots        -0.01046753  0.0257856051  0.0005360138    0.0005859438
    Yelbord         -0.02769681  0.0005360138  0.0841059387    0.0031816032
    Yelbordredspots -0.02510175  0.0005859438  0.0031816032    0.0818867552
    attr(,"dispersion")
    [1] 1
    attr(,"class")
    [1] "vcov.gnm"
    > covs <- vcov(Davidson2)
    > covs <- covs[-1,-1]
    > pd1 <- function (thetavec) { # function for partial derivatives
      +   tot <- sum(exp(thetavec))
      +   exp(thetavec[1])/tot - exp(2*thetavec[1])/tot^2
      + }
    > 
      > pd2 <- function (index, thetavec) {
        +   tot <- sum(exp(thetavec))
        +   -(exp(thetavec[1] + thetavec[index])/tot^2)
        + }
    > 
      > 
      > cycle <- function (vec) { # cycle through each treatment
        +   c(vec[length(vec)], vec[1:(length(vec)-1)])
        + }
    > 
      > pds <- matrix(0, nrow=3, ncol=3, dimnames=list(names(probs),
                                                       +                                                names(probs)))
    > for (i in 1:4) {
      + for (j in i:4) {# calculate partial derivatives
        + if (i == j) pds[j,i] <- pd1(probs) else {
          +  pds[j,i] <- pd2(j, probs)
          + }
        + }
      + probs <- cycle(probs)
      + }
    Error in `[<-`(`*tmp*`, j, i, value = NA_real_) : subscript out of bounds
    > 
      > 
      > pds[upper.tri(pds)] <- pds[lower.tri(pds)]
    > 
      > ses <- sqrt(diag(t(pds) %*% covs %*% pds)) # calculate standard errors
    > ses
    Redspots         Yelbord Yelbordredspots 
    0.06404208      0.01954077      0.01997008 

