# experiment 1: red spot vs red spot with yellow border 
library(survival)
twogroups <- read.csv("red spot versus red spot with yellow border old and new data combined.csv")
twogroups_analysis <-survdiff(Surv(time, status) ~ colour_stimuli, data = twogroups)
twogroups_analysis
Call:
  survdiff(formula = Surv(time, status) ~ colour_stimuli, data = twogroups)

N Observed Expected (O-E)^2/E (O-E)^2/V
colour_stimuli=red                7        0     4.79      4.79      9.52
colour_stimuli=redspot_yelborder 14       14     9.21      2.49      9.52

Chisq= 9.5  on 1 degrees of freedom, p= 0.00203 


#compare redspot/yellow border stimuli from experiment 1a and 1b
library(survival)
compare_two_redspot_yellowborder_groups <- read.csv("first exp red yellow vs second exp red yellow.csv")
compare_two_redspot_yellowborder_groups_analysis <-survdiff(Surv(time, status) ~ colour_stimuli, data = compare_two_redspot_yellowborder_groups)
compare_two_redspot_yellowborder_groups_analysis
Call:
  survdiff(formula = Surv(time, status) ~ colour_stimuli, data = compare_two_redspot_yellowborder_groups)

N Observed Expected (O-E)^2/E (O-E)^2/V
colour_stimuli=redyellowfirst  7        7     5.85     0.228     0.459
colour_stimuli=redyellowsecond 7        7     8.15     0.164     0.459

Chisq= 0.5  on 1 degrees of freedom, p= 0.498




#compare yellow border only vs yellowborder with red spot
compare_yellow_border_vs_yellowborderredspot<- read.csv("border vs border and spot.csv")
compare_yellow_border_vs_yellowborderredspot_analysis <-survdiff(Surv(time, status) ~ colour_stimuli, data = compare_yellow_border_vs_yellowborderredspot)
compare_yellow_border_vs_yellowborderredspot_analysis
Call:
  survdiff(formula = Surv(time, status) ~ colour_stimuli, data = compare_yellow_border_vs_yellowborderredspot)

N Observed Expected (O-E)^2/E (O-E)^2/V
colour_stimuli=border     9        9     7.73     0.209     0.404
colour_stimuli=redyellow 14       14    15.27     0.106     0.404

Chisq= 0.4  on 1 degrees of freedom, p= 0.525